//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "unitlist.h"
#include "unitlptdmx.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TformList *formList = NULL;
//---------------------------------------------------------------------------
__fastcall TformList::TformList(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TformList::FormCreate(TObject *Sender)
{
        BYTE i;
        for (int i = 0; i <= 0xF; i++)
        {
                stringgridDMXValues->Cells[0][i + 1] = IntToHex(i, 1);
                stringgridDMXValues->Cells[i + 1][0] = IntToHex(i, 1);
        }
}
//---------------------------------------------------------------------------
/*
        Pre: true;
        Post: (als readOnly = true dan is het bewerken van cellen in stringgridDMXValues niet mogelijk) en
              (als readOnly = false dan is het bewerken van cellen in stringgridDMXValues wel mogelijk);
*/
void __fastcall TformList::setReadOnly(bool readOnly)
{
        if (readOnly)
                stringgridDMXValues->Options = stringgridDMXValues->Options >> goEditing;
        else
                stringgridDMXValues->Options = stringgridDMXValues->Options << goEditing;
}
//---------------------------------------------------------------------------
/*
        Pre: text != NULL;
        Post: de weergegeven tekst in elke cel in stringgridDMXValues = text;
*/
void __fastcall TformList::fillValues(char * text)
{
        for (int col = 1; col <= 16; col++)
                for (int row = 1; row <= 16; row++)
                        stringgridDMXValues->Cells[col][row] = text;
}
//---------------------------------------------------------------------------
/*
        Pre: text != NULL;
        Post: de weergegeven tekst in de cel behorende bij kanaal channel in
              stringgridDMXValues = text;
*/
void __fastcall TformList::setValue(BYTE channel, char * text)
{
        stringgridDMXValues->Cells[channel % 16 + 1][channel / 16 + 1] = text;
}
//---------------------------------------------------------------------------
/*
        Pre: true;
        Post: getValue = de weergegeven tekst in de cel behorende bij kanaal
              channel in stringgridDMXValues;
*/
char * __fastcall TformList::getValue(BYTE channel)
{
        return stringgridDMXValues->Cells[channel % 16 + 1][channel / 16 + 1].c_str();
}
//---------------------------------------------------------------------------

void __fastcall TformList::FormClose(TObject *Sender, TCloseAction &Action)
{
        if (stringgridDMXValues->Options.Contains(goEditing))
        {
                Action = caNone;
                formLPTDMX->checkboxShowOutputs->Checked = false;
        }
        else
                Action = caFree;
}
//---------------------------------------------------------------------------

