//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "unitlptdmx.h"
#include "unitlptdmxlib.h"
#include "unitlist.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TformLPTDMX *formLPTDMX;

#define BASE 0x378

HANDLE hLPTDMX = INVALID_HANDLE_VALUE;

//---------------------------------------------------------------------------
__fastcall TformLPTDMX::TformLPTDMX(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TformLPTDMX::listBoxTabsClick(TObject *Sender)
{
        if (listBoxTabs->ItemIndex > -1)
        {
                groupBoxDriverControl->Hide();
                groupBoxCommandsBasic->Hide();
                groupBoxCommandsInput->Hide();
                groupBoxCommandsOutput->Hide();
                if (listBoxTabs->Items->Strings[listBoxTabs->ItemIndex] == "Driver control")
                        groupBoxDriverControl->Show();
                else if (listBoxTabs->Items->Strings[listBoxTabs->ItemIndex] == "Basic commands")
                        groupBoxCommandsBasic->Show();
                else if (listBoxTabs->Items->Strings[listBoxTabs->ItemIndex] == "Input commands")
                        groupBoxCommandsInput->Show();
                else if (listBoxTabs->Items->Strings[listBoxTabs->ItemIndex] == "Output commands")
                        groupBoxCommandsOutput->Show();
        }
}
//---------------------------------------------------------------------------
void __fastcall TformLPTDMX::buttonOpenClick(TObject *Sender)
{
        if ((hLPTDMX = lptdmxOpen(editDevice->Text.c_str(), BASE)) == INVALID_HANDLE_VALUE)
                MessageBox(Handle, "Could not open the LPTDMX driver.\nMake sure that the LPTDMX driver has been installed en started.", Caption.c_str(), MB_ICONERROR);
}
//---------------------------------------------------------------------------
void __fastcall TformLPTDMX::buttonCloseClick(TObject *Sender)
{
        lptdmxClose(hLPTDMX);
        hLPTDMX = INVALID_HANDLE_VALUE;
}
//---------------------------------------------------------------------------
void __fastcall TformLPTDMX::buttonCommandResyncClick(TObject *Sender)
{
        if (!lptdmxCommandResync(hLPTDMX))
                ShowMessage("Error calling lptdmxCommandResync.");
}
//---------------------------------------------------------------------------
void __fastcall TformLPTDMX::buttonCommandFinishClick(TObject *Sender)
{
        if (!lptdmxCommandFinish(hLPTDMX))
                ShowMessage("Error calling lptdmxCommandFinish.");
}
//---------------------------------------------------------------------------
void __fastcall TformLPTDMX::buttonCommandEchoClick(TObject *Sender)
{
        if (editEchoCharacter->Text.Length() > 0)
        {
                BYTE character = editEchoCharacter->Text[1];
                if (lptdmxCommandEcho(hLPTDMX, character))
                        editEchoCharacter2->Text = (char)character;
                else
                        ShowMessage("Error calling lptdmxCommandEcho.");
        }
        else
        {
                editEchoCharacter2->Text = " ";
                ShowMessage("No source character entered.");
        }
}
//---------------------------------------------------------------------------
void __fastcall TformLPTDMX::buttonCommandInputClick(TObject *Sender)
{
        BYTE value;
        if (lptdmxCommandInput(hLPTDMX, updownInputChannel->Position - 1, value))
                editInputValue->Text = IntToStr(value);
        else
                ShowMessage("Error calling lptdmxCommandInput.");
}
//---------------------------------------------------------------------------
void __fastcall TformLPTDMX::buttonCommandBulkInputClick(TObject *Sender)
{
        BYTE *values = (BYTE *)malloc(updownBulkInputCount->Position);
        try
        {
                if (values != NULL)
                        if (lptdmxCommandBulkInput(hLPTDMX, updownBulkInputCount->Position, values))
                        {
                                TformList * f = new TformList(this);
                                for (int i = 0; i < updownBulkInputCount->Position; i++)
                                        f->setValue(i, IntToStr(values[i]).c_str());
                                for (int i = updownBulkInputCount->Position; i < INPUT_CHANNELCOUNT; i++)
                                        f->setValue(i, "");
                                f->Show();
                        }
                        else
                                ShowMessage("Error calling lptdmxCommandBulkInput.");
                else
                        ShowMessage("Insufficient memory.");
        }
        __finally
        {
                free(values);
        }
}
//---------------------------------------------------------------------------
void __fastcall TformLPTDMX::buttonCommandOutputClick(TObject *Sender)
{
        if (!lptdmxCommandOutput(hLPTDMX, updownOutputChannel->Position - 1, updownOutputValue->Position))
                ShowMessage("Error calling lptdmxCommandOutput.");
}
//---------------------------------------------------------------------------

void __fastcall TformLPTDMX::checkboxShowOutputsClick(TObject *Sender)
{
        if (checkboxShowOutputs->Checked)
        {
                // controleer voor de zekerheid of er niet al een venster bestond.
                // was er al een venster, gebruik dan het bestaande venster.
                if (formList == NULL)
                        formList = new TformList(this);
                formList->Show();
                formList->setReadOnly(FALSE);
        }
        else
        {
                formList->Free();
                formList = NULL;
        }
}
//---------------------------------------------------------------------------

void __fastcall TformLPTDMX::buttonCommandBulkOutputClick(TObject *Sender)
{
        if (formList != NULL)
        {
                BYTE *values = (BYTE *)malloc(updownBulkOutputCount->Position);
                if (values != NULL)
                {
                        for (int i = 0; i < updownBulkOutputCount->Position; i++)
                                values[i] = StrToIntDef(formList->getValue(i), 0);
                        if (!lptdmxCommandBulkOutput(hLPTDMX, updownBulkOutputCount->Position, values))
                                ShowMessage("Error calling lptdmxCommandBulkOutput.");
                }
                else
                        ShowMessage("Insufficient memory.");
        }
        else
                ShowMessage("Make sure that the outputs are visible."); 
}
//---------------------------------------------------------------------------

