//---------------------------------------------------------------------------

#include <windows.h>
#include <winbase.h>
#include <winioctl.h>
#pragma hdrstop

#include "unitlptdmxlib.h"
#include "..\driver\ioctl.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)

HANDLE hLPTDMX = INVALID_HANDLE_VALUE;
//---------------------------------------------------------------------------
/*
        pre: device = een geldige naam van een LPTDMX apparaat EN
             ioAddress = een geldig I/O beginadres van een parallelle poort;
        post: (als lptdmxOpen <> INVALID_HANDLE_VALUE dan
              er is een handle geopend naar het apparaat device EN
              het apparaat maakt gebruik van ioAddress EN
              lptdmxOpen = bijbehorende handle) EN
              (als lptdmxOpen = INVALID_HANDLE_VALUE dan
              er is geen handle geopend naar het apparaat device)
*/
HANDLE lptdmxOpen(char * device, WORD ioAddress)
{
        return CreateFile(
                device,
                GENERIC_READ | GENERIC_WRITE,
                0,
                NULL,
                OPEN_EXISTING,
                FILE_ATTRIBUTE_NORMAL,
                NULL
        );
}
//---------------------------------------------------------------------------
/*
        pre: hLPTDMX = een geldige handle voor een LPTDMX apparaat;
        post: de handle hLPTDMX is gesloten;
*/
void lptdmxClose(HANDLE hLPTDMX)
{
        CloseHandle(hLPTDMX);
}
//---------------------------------------------------------------------------
// deze functie wordt niet meer gebruikt, maar staat hier als voorbeeld.
bool lptdmxCommandResync(HANDLE hLPTDMX)
{
/*        DWORD bBytesReturned;
        return DeviceIoControl(
                hLPTDMX,
                IOCTL_LPTDMX_RESYNC,
                NULL,
                0,
                NULL,
                0,
                &bBytesReturned,
                NULL
        );*/
        return false;
}
//---------------------------------------------------------------------------
// deze functie wordt niet meer gebruikt, maar staat hier als voorbeeld.
bool lptdmxCommandFinish(HANDLE hLPTDMX)
{
/*        DWORD bBytesReturned;
        return DeviceIoControl(
                hLPTDMX,
                IOCTL_LPTDMX_FINISH,
                NULL,
                0,
                NULL,
                0,
                &bBytesReturned,
                NULL
        );*/
        return false;
}
//---------------------------------------------------------------------------
/*
        pre: hLPTDMX = een geldige handle voor een LPTDMX apparaat;
        post: als lptdmxCommandEcho = true dan
              (is het echo commando verzonden naar het apparaat aangegeven
              door hLPTDMX, samen met de byte (pre)character en
              character = het door het apparaat teruggegeven karakter)
*/
bool lptdmxCommandEcho(HANDLE hLPTDMX, /* IN OUT */ BYTE &character)
{
        DWORD bBytesReturned;
        IOCTL_LPTDMX_ECHO_INOUT bIOCTL_LPTDMX_ECHO_INOUT;
        bIOCTL_LPTDMX_ECHO_INOUT.character = character;
        bool success =
                DeviceIoControl(
                        hLPTDMX,
                        IOCTL_LPTDMX_ECHO,
                        &bIOCTL_LPTDMX_ECHO_INOUT,
                        sizeof(bIOCTL_LPTDMX_ECHO_INOUT),
                        &bIOCTL_LPTDMX_ECHO_INOUT,
                        sizeof(bIOCTL_LPTDMX_ECHO_INOUT),
                        &bBytesReturned,
                        NULL
                );
        character = bIOCTL_LPTDMX_ECHO_INOUT.character;
        return success;
}
//---------------------------------------------------------------------------
bool lptdmxCommandInput(HANDLE hLPTDMX, BYTE channel, BYTE &value)
{
        DWORD bBytesReturned;
        IOCTL_LPTDMX_INPUT_IN  bIOCTL_LPTDMX_INPUT_IN;
        IOCTL_LPTDMX_INPUT_OUT bIOCTL_LPTDMX_INPUT_OUT;
        bIOCTL_LPTDMX_INPUT_IN.channel = channel;
        bool success =
                DeviceIoControl(
                        hLPTDMX,
                        IOCTL_LPTDMX_INPUT,
                        &bIOCTL_LPTDMX_INPUT_IN,
                        sizeof(bIOCTL_LPTDMX_INPUT_IN),
                        &bIOCTL_LPTDMX_INPUT_OUT,
                        sizeof(bIOCTL_LPTDMX_INPUT_OUT),
                        &bBytesReturned,
                        NULL
                );
        value = bIOCTL_LPTDMX_INPUT_OUT.value;
        return success;
}
//---------------------------------------------------------------------------
bool lptdmxCommandBulkInput(HANDLE hLPTDMX, BYTE channels, BYTE * values)
{
        DWORD bNumberOfBytesRead;
        return ReadFile(
                hLPTDMX,
                values,
                channels,
                &bNumberOfBytesRead,
                NULL
        );
}
//---------------------------------------------------------------------------
bool lptdmxCommandOutput(HANDLE hLPTDMX, BYTE channel, BYTE value)
{
        DWORD bBytesReturned;
        IOCTL_LPTDMX_OUTPUT_IN bIOCTL_LPTDMX_OUTPUT_IN;
        bIOCTL_LPTDMX_OUTPUT_IN.channel = channel;
        bIOCTL_LPTDMX_OUTPUT_IN.value   = value;
        return DeviceIoControl(
                hLPTDMX,
                IOCTL_LPTDMX_OUTPUT,
                &bIOCTL_LPTDMX_OUTPUT_IN,
                sizeof(bIOCTL_LPTDMX_OUTPUT_IN),
                NULL,
                0,
                &bBytesReturned,
                NULL
        );
}
//---------------------------------------------------------------------------
bool lptdmxCommandBulkOutput(HANDLE hLPTDMX, BYTE channels, BYTE * values)
{
        DWORD bNumberOfBytesWritten;
        return WriteFile(
                hLPTDMX,
                values,
                channels,
                &bNumberOfBytesWritten,
                NULL
        );
}
//---------------------------------------------------------------------------

